"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.getInstructionRemainingAccountsFragment = void 0;
const shared_1 = require("../../../shared");
const common_1 = require("./common");
function getInstructionRemainingAccountsFragment(instructionNode) {
    const { remainingAccounts } = instructionNode;
    const remainingAccountsFragment = (0, common_1.fragmentWithContextMap)('').addImports('solanaInstructions', ['IAccountMeta']);
    if ((remainingAccounts === null || remainingAccounts === void 0 ? void 0 : remainingAccounts.kind) === 'arg') {
        remainingAccountsFragment.addImports('solanaInstructions', ['AccountRole']);
    }
    else if ((remainingAccounts === null || remainingAccounts === void 0 ? void 0 : remainingAccounts.kind) === 'resolver') {
        remainingAccountsFragment.addImports(remainingAccounts.importFrom, (0, shared_1.camelCase)(remainingAccounts.name));
        remainingAccountsFragment.interfaces.add([
            'getProgramAddress',
            'getProgramDerivedAddress',
        ]);
    }
    remainingAccountsFragment.setRender((0, common_1.fragmentFromTemplate)('instructionRemainingAccounts.njk', {
        remainingAccounts,
    }).render);
    return remainingAccountsFragment;
}
exports.getInstructionRemainingAccountsFragment = getInstructionRemainingAccountsFragment;
//# sourceMappingURL=instructionRemainingAccounts.js.map