"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.getTypeFragment = void 0;
const shared_1 = require("../../../shared");
const common_1 = require("./common");
function getTypeFragment(name, manifest, docs = []) {
    const strictName = (0, shared_1.pascalCase)(name);
    const looseName = `${strictName}Args`;
    const typeFragment = (0, common_1.fragmentFromTemplate)('type.njk', {
        strictName,
        looseName,
        manifest,
        docs,
    });
    if (!manifest.isEnum) {
        typeFragment.mergeImportsWith(manifest.strictType, manifest.looseType);
    }
    return typeFragment;
}
exports.getTypeFragment = getTypeFragment;
//# sourceMappingURL=type.js.map