import * as nodes from '../../nodes';
import { SizeStrategy } from '../../shared';
import { Visitor } from '../../visitors';
import { Fragment } from './fragments';
import { TypeManifest } from './TypeManifest';
export declare class GetTypeManifestVisitor implements Visitor<TypeManifest> {
    private parentName;
    visitRoot(): TypeManifest;
    visitProgram(): TypeManifest;
    visitAccount(account: nodes.AccountNode): TypeManifest;
    visitAccountData(accountData: nodes.AccountDataNode): TypeManifest;
    visitInstruction(instruction: nodes.InstructionNode): TypeManifest;
    visitInstructionAccount(): TypeManifest;
    visitInstructionDataArgs(instructionDataArgs: nodes.InstructionDataArgsNode): TypeManifest;
    visitInstructionExtraArgs(instructionExtraArgs: nodes.InstructionExtraArgsNode): TypeManifest;
    visitDefinedType(definedType: nodes.DefinedTypeNode): TypeManifest;
    visitError(): TypeManifest;
    visitArrayType(arrayType: nodes.ArrayTypeNode): TypeManifest;
    visitLinkType(linkType: nodes.LinkTypeNode): TypeManifest;
    visitEnumType(enumType: nodes.EnumTypeNode): TypeManifest;
    visitEnumEmptyVariantType(enumEmptyVariantType: nodes.EnumEmptyVariantTypeNode): TypeManifest;
    visitEnumStructVariantType(enumStructVariantType: nodes.EnumStructVariantTypeNode): TypeManifest;
    visitEnumTupleVariantType(enumTupleVariantType: nodes.EnumTupleVariantTypeNode): TypeManifest;
    visitMapType(mapType: nodes.MapTypeNode): TypeManifest;
    visitOptionType(optionType: nodes.OptionTypeNode): TypeManifest;
    visitSetType(setType: nodes.SetTypeNode): TypeManifest;
    visitStructType(structType: nodes.StructTypeNode): TypeManifest;
    visitStructFieldType(structFieldType: nodes.StructFieldTypeNode): TypeManifest;
    visitTupleType(tupleType: nodes.TupleTypeNode): TypeManifest;
    visitBoolType(boolType: nodes.BoolTypeNode): TypeManifest;
    visitBytesType(bytesType: nodes.BytesTypeNode): TypeManifest;
    visitNumberType(numberType: nodes.NumberTypeNode): TypeManifest;
    visitNumberWrapperType(numberWrapperType: nodes.NumberWrapperTypeNode): TypeManifest;
    visitPublicKeyType(): TypeManifest;
    visitStringType(stringType: nodes.StringTypeNode): TypeManifest;
    protected createDocblock(docs: string[]): string;
    protected getArrayLikeSizeOption(size: SizeStrategy): {
        encoder: Fragment;
        decoder: Fragment;
    };
}
